indexing
   description : "C Handle (T *)"
   project     : "EiffelBDB - An Eiffel interface to the Berkeley DB"
   author      : "Pirmin Kalberer <kalberer@spin.ch>"
   copyright   : "Copyright (c) 1999, Pirmin Kalberer"
   date        : "$Date: 2000/01/08 16:19:03 $"
   revision    : "$Revision: 1.2 $"
	 
class BDB_C_HANDLE[T]

   -- normally used as expanded class replacing non-ETL $-calls

feature 

   item: T
	 -- Memory handled by Eiffel GC
	 -- Never deallocate it in the C code!

feature

   set_item(value: like item) is
      do
         item := value
      end

   handle: POINTER is
	 -- C pointer to item
	 -- Warning: memory of item is handled by Eiffel GC!
	 -- Warning: pointer validity time is compiler dependent!
      do
         Result := c_ptr($item)
      end
   
feature { NONE }
   
   c_ptr(p: POINTER): POINTER is
	 -- dummy function, because $-operator is allowed in function call only
      do
         Result := p
      end
   
end
