indexing
   description : "Common features"
   project     : "EiffelBDB - An Eiffel interface to the Berkeley DB"
   author      : "Pirmin Kalberer <kalberer@spin.ch>"
   copyright   : "Copyright (c) 1999, Pirmin Kalberer"
   date        : "$Date: 1999/11/28 18:58:15 $"
   revision    : "$Revision: 1.1 $"
	 
class BDB_ENV_COMMON
   
inherit
   DB_WRAPPER
   BDB_EXTERNAL_ROUTINES
    
feature

   version: STRING is
	 -- Version information.
	 -- static char *version(int *major, int *minor, int *patch)
      do
	 Result := pointer_to_string(Db_version_string_const)
      end
   
   strerror(err: INTEGER): STRING is
	 -- Convert DB errors to strings
	 --        static char *strerror(int);
      do
	 Result := pointer_to_string(db_strerror(err))
      end
   
   runtime_error(caller: STRING; err: INTEGER; env: BDB_ENV) is
	 -- static int runtime_error(const char *caller, int err
	 --                          int in_destructor = 0, int force_throw = 0);
      do
	 print(caller); print(": "); print(strerror(err)); print("%N") --FIXME: stderr with env.prefix
	 --what_ = dupString(tmpString(prefix1, ": ", caller, ": ", strerror(err))
      end
	      
feature

   get_struct_ptr(eclass: BDB_WRAPPED_STRUCT): POINTER is
      do
	 if eclass /= Void then
	    Result := eclass.struct_ptr
	 end
      end

end
