indexing
   description : ""
   project     : "EiffelBDB - An Eiffel interface to the Berkeley DB"
   author      : "Pirmin Kalberer <kalberer@spin.ch>"
   copyright   : "Copyright (c) 1999, Pirmin Kalberer"
   date        : "$Date: 1999/11/28 18:58:15 $"
   revision    : "$Revision: 1.1 $"
	 
----------------------------------------------------------------
----------------------------------------------------------------
--
-- Exception classes
--

-- Almost any error in the DB library throws a BDB_EXCEPTION.
-- Every exception should be considered an abnormality
-- (e.g. bug, misuse of DB, file system error).
--

class BDB_EXCEPTION
   
inherit
   DB_WRAPPER
   
creation
   make
   
feature
     exit_DbException is
    -- C++: virtual ~DbException()
      do
      end
    DbException(int err) is
    -- C++: DbException(int err)
      do
      end
    DbException(description: STRING) is
    -- C++: DbException(const char *description)
      do
      end
    DbException(prefix: STRING; int err) is
    -- C++: DbException(const char *prefix, int err)
      do
      end
    DbException(prefix1: STRING; prefix2: STRING; int err) is
    -- C++: DbException(const char *prefix1, const char *prefix2, int err)
    const int get_errno is
    -- C++: const int get_errno()
      do
      end
     what: STRING is
    -- C++: virtual const char *what() const
      do
      end

    make_from_other(other: like Current) is
    -- C++: DbException(const DbException &)
      do
      end
	copy(other: like Current) is
    -- C++: DbException &operator = (const DbException &)
      do
      end

feature {NONE}
   
    what: STRING_;
    -- C++: char *what_
      do
      end
    int err_;                   -- errno
    -- C++: int err_;                   -- errn
      do
      end
end


