indexing
   description : "C struct wrapper"
   project     : "EiffelBDB - An Eiffel interface to the Berkeley DB"
   author      : "Pirmin Kalberer <kalberer@spin.ch>"
   copyright   : "Copyright (c) 1999, Pirmin Kalberer"
   date        : "$Date: 1999/11/28 18:58:15 $"
   revision    : "$Revision: 1.1 $"
	 
class BDB_WRAPPED_STRUCT
   
inherit
   BDB_EXTERNAL_ROUTINES
   
creation
   make
       
feature { NONE }

   struct: STRING
	 -- The internal memory for the string is used for storing a C struct
	 -- This memory is deallocated by the GC together with `struct'
   
feature

   make(size: INTEGER) is
	 -- allocate `size' bytes for a C struct
      do
	 !BDB_STRING!struct.make_initialized(size)
      end
   
   struct_ptr: POINTER is
	 -- Pointer to C struct
	 -- Warning: pointer validity time is compiler dependent!
      do
	 Result := string_to_pointer(struct)
      end
   
invariant
   struct_ptr_initialized: struct /= Void
        
end
