/* Emacs-Mode: -*-C-*- */
/*
indexing
   description : "Input file for swigeiffel"
   project     : "EiffelBDB - An Eiffel interface to the Berkeley DB"
   author      : "Pirmin Kalberer <kalberer@spin.ch>"
   copyright   : "Copyright (c) 1999, Pirmin Kalberer"
   date        : "$Date: 1999/11/28 18:58:15 $"
   revision    : "$Revision: 1.1 $"
*/

%module db

%{
#include "db.h"
%}

#define	_DB_H_
#define	_SYS_TYPES_H	1
#define	_FEATURES_H	1
#define __KERNEL_STRICT_NAMES
#define	__USE_ANSI	1
#define	_BSD_SOURCE	1
#define	_SVID_SOURCE	1
#define	_POSIX_SOURCE	1
//#define	_POSIX_C_SOURCE	199309L
#define	__USE_POSIX	1
#define	__USE_POSIX2	1
#define	__USE_POSIX199309	1
#define	__USE_MISC	1
#define	__USE_BSD	1
#define	__USE_SVID	1
#define __GNU_LIBRARY__ 6
#define	__GLIBC__	2
#define	__GLIBC_MINOR__	0
#define	_SYS_CDEFS_H	1

#define	__P(args)	args	
#define	__DOTS		, ...
/*
#define	__CONCAT(x,y)	x ## y
#define	__STRING(x)	#x
*/
#define __ptr_t void *
//#define __long_double_t  long double

#define	__BEGIN_DECLS
#define	__END_DECLS

#define __stub___ieee754_j0l
#define __stub___ieee754_j1l
#define __stub___ieee754_jnl
#define __stub___ieee754_lgammal_r
#define __stub___ieee754_rem_pio2l
#define __stub___ieee754_y0l
#define __stub___ieee754_y1l
#define __stub___ieee754_ynl
#define __stub___kernel_cosl
#define __stub___kernel_rem_pio2l
#define __stub___kernel_sinl
#define __stub___kernel_tanl
#define __stub_chflags
#define __stub_erfcl
#define __stub_erfl
#define __stub_fchflags
#define __stub_fexecve
#define __stub_gtty
#define __stub_madvise
#define __stub_revoke
#define __stub_setlogin
#define __stub_sigaltstack
#define __stub_sigstack
#define __stub_sstk
#define __stub_stty

#define	_GNU_TYPES_H	1
 
typedef unsigned char __u_char;
typedef unsigned short __u_short;
typedef unsigned int __u_int;
//typedef unsigned long __u_long;

//typedef unsigned long long int __u_quad_t;
//typedef long long int __quad_t;

//typedef __quad_t *__qaddr_t;

//typedef __u_quad_t __dev_t;		 
typedef __u_int __uid_t;		 
typedef __u_int __gid_t;		 
//typedef __u_long __ino_t;		 
typedef __u_int __mode_t;		 
typedef __u_int __nlink_t; 		 
//typedef long int __off_t;		 
typedef int __off_t;		 
//typedef __quad_t __loff_t;		 
typedef int __pid_t;			 
typedef int __ssize_t;			 

//typedef struct
//  {
//    int __val[2];
//  } __fsid_t;				 

typedef int __daddr_t;			 
typedef char *__caddr_t;
//typedef long int __time_t;
typedef int __time_t;
//typedef long int __swblk_t;		 

//typedef long int __clock_t;
 
//typedef unsigned long int __fd_mask;
 
#define __FD_SETSIZE	1024
/* 
#define __NFDBITS	(8 * sizeof (__fd_mask))
#define	__FDELT(d)	((d) / __NFDBITS)
#define	__FDMASK(d)	((__fd_mask) 1 << ((d) % __NFDBITS))
 
typedef struct
  {
    __fd_mask fds_bits[1024  / (8 * sizeof (__fd_mask)) ];
  } __fd_set;
*/
typedef int __key_t;

typedef unsigned short int __ipc_pid_t;

typedef __u_char u_char;
typedef __u_short u_short;
typedef __u_int u_int;
//typedef __u_long u_long;
//typedef __quad_t quad_t;
//typedef __u_quad_t u_quad_t;
typedef __fsid_t fsid_t;

typedef __dev_t dev_t;
typedef __gid_t gid_t;
typedef __ino_t ino_t;
typedef __mode_t mode_t;
typedef __nlink_t nlink_t;
typedef __off_t off_t;
typedef __loff_t loff_t;
typedef __pid_t pid_t;
typedef __uid_t uid_t;

typedef __ssize_t ssize_t;
#define ssize_t ssize_t

typedef __daddr_t daddr_t;
typedef __caddr_t caddr_t;

typedef __key_t key_t;

#define	__need_time_t

#define	__time_t_defined	1
 
typedef __time_t time_t;

#define	__need_size_t

#define __size_t__	
#define _SIZE_T
#define _SYS_SIZE_T_H
#define _T_SIZE_
#define _T_SIZE
#define __SIZE_T
#define _SIZE_T_
#define _BSD_SIZE_T_
#define _SIZE_T_DEFINED_
#define _SIZE_T_DEFINED
#define ___int_size_t_h
#define _GCC_SIZE_T
#define _SIZET_
#define __size_t

typedef unsigned int size_t;
 
//typedef unsigned long int ulong;
typedef unsigned short int ushort;
typedef unsigned int uint;

/*
#define __intN_t(N, MODE) typedef int int##N##_t __attribute__ ((__mode__ (MODE)))
#define __u_intN_t(N, MODE) typedef unsigned int u_int##N##_t __attribute__ ((__mode__ (MODE)))
*/
/*
typedef int int8_t __attribute__ ((__mode__ (  __QI__ ))) ;
typedef unsigned int u_int8_t __attribute__ ((__mode__ (  __QI__ ))) ;
typedef int int16_t __attribute__ ((__mode__ (  __HI__ ))) ;
typedef unsigned int u_int16_t __attribute__ ((__mode__ (  __HI__ ))) ;
typedef int int32_t __attribute__ ((__mode__ (  __SI__ ))) ;
typedef unsigned int u_int32_t __attribute__ ((__mode__ (  __SI__ ))) ;
typedef int int64_t __attribute__ ((__mode__ (  __DI__ ))) ;
typedef unsigned int u_int64_t __attribute__ ((__mode__ (  __DI__ ))) ;

typedef int register_t __attribute__ ((__mode__ (__word__)));
*/
typedef int int8_t;
typedef unsigned int u_int8_t;
typedef int int16_t;
typedef unsigned int u_int16_t;
typedef int int32_t;
typedef unsigned int u_int32_t;
typedef int int64_t;
typedef unsigned int u_int64_t;

#define __BIT_TYPES_DEFINED__	1

#define	_ENDIAN_H	1

#define	__LITTLE_ENDIAN	1234
#define	__BIG_ENDIAN	4321
#define	__PDP_ENDIAN	3412

#define __BYTE_ORDER __LITTLE_ENDIAN

#define	LITTLE_ENDIAN	__LITTLE_ENDIAN
#define	BIG_ENDIAN	__BIG_ENDIAN
#define	PDP_ENDIAN	__PDP_ENDIAN
#define	BYTE_ORDER	__BYTE_ORDER

#define _SYS_SELECT_H	1

#define _SELECTBITS_H	1


/*
#define __FD_ZERO(fdsetp) __asm__ __volatile__ ("cld; rep; stosl"	: "=m" ((fdsetp)->fds_bits[__FDELT (__FD_SETSIZE)]) : "a" (0), "c" (sizeof (__fd_set)	/ sizeof (__fd_mask)),	"D" (&(fdsetp)->fds_bits[0])	:"cx","di","memory")
#define __FD_SET(fd, fdsetp) __asm__ __volatile__ ("btsl %1,%0"	: "=m" ((fdsetp)->fds_bits[__FDELT (fd)])	: "r" (((int) (fd)) % __NFDBITS)	: "cc","memory")
#define __FD_CLR(fd, fdsetp) __asm__ __volatile__ ("btrl %1,%0"	: "=m" ((fdsetp)->fds_bits[__FDELT (fd)])	: "r" (((int) (fd)) % __NFDBITS)	: "cc","memory")
#define __FD_ISSET(fd, fdsetp) (__extension__	({register char __result;	__asm__ __volatile__ ("btl %1,%2 ; setcb %b0"	: "=q" (__result)	: "r" (((int) (fd)) % __NFDBITS),	"m" (((fdsetp)->fds_bits)[__FDELT (fd)]) : "cc");	__result; }))
*/
#define __need_timespec

#define	__timespec_defined	1

/*
struct timespec
  {
    long int tv_sec;		 
    long int tv_nsec;		 
  };
*/

struct timeval;

typedef __fd_mask fd_mask;
 
typedef __fd_set fd_set;
 
#define	FD_SETSIZE		__FD_SETSIZE
 
#define	NFDBITS			__NFDBITS
 
#define	FD_SET(fd, fdsetp)	__FD_SET ((fd), (fdsetp))
#define	FD_CLR(fd, fdsetp)	__FD_CLR ((fd), (fdsetp))
#define	FD_ISSET(fd, fdsetp)	__FD_ISSET ((fd), (fdsetp))
#define	FD_ZERO(fdsetp)		__FD_ZERO (fdsetp)
/*
extern int __select  (int __nfds, __fd_set *__readfds,
			  __fd_set *__writefds, __fd_set *__exceptfds,
			  struct timeval *__timeout)  ;
extern int select  (int __nfds, __fd_set *__readfds,
			__fd_set *__writefds, __fd_set *__exceptfds,
			struct timeval *__timeout)  ;


extern int __pselect  (int __nfds, __fd_set *__readfds,
			   __fd_set *__writefds, __fd_set *__exceptfds,
			   struct timespec *__timeout)  ;
extern int pselect  (int __nfds, __fd_set *__readfds,
			 __fd_set *__writefds, __fd_set *__exceptfds,
			 struct timespec *__timeout)  ;
*/
/*
#define _STDIO_H
#define _STDIO_USES_IOSTREAM

#define _IO_STDIO_H

#define _G_config_h 1

#define __need_size_t
#define __need_wint_t
#define __need_NULL

#define _WINT_T


#define __WINT_TYPE__ unsigned int

typedef unsigned int  wint_t;

#define NULL ((void *)0)

#define _G_size_t	size_t
#define _G_fpos_t	__off_t
#define _G_ssize_t	__ssize_t
#define _G_off_t	__off_t
#define	_G_pid_t	__pid_t
#define	_G_uid_t	__uid_t
#define _G_wint_t	wint_t

typedef int _G_int16_t __attribute__ ((__mode__ (__HI__)));
typedef int _G_int32_t __attribute__ ((__mode__ (__SI__)));
typedef unsigned int _G_uint16_t __attribute__ ((__mode__ (__HI__)));
typedef unsigned int _G_uint32_t __attribute__ ((__mode__ (__SI__)));

#define _G_HAVE_BOOL 1
 
#define _G_HAVE_ATEXIT 1
#define _G_HAVE_SYS_CDEFS 1
#define _G_HAVE_SYS_WAIT 1
#define _G_NEED_STDARG_H 1
#define _G_va_list __gnuc_va_list

#define _G_HAVE_PRINTF_FP 1
#define _G_HAVE_MMAP 1
#define _G_HAVE_LONG_DOUBLE_IO 1
 
#define _G_HAVE_ST_BLKSIZE defined (_STATBUF_ST_BLKSIZE)

#define _G_BUFSIZ 8192
 
#define _G_NAMES_HAVE_UNDERSCORE 0
#define _G_VTABLE_LABEL_HAS_LENGTH 1
#define _G_USING_THUNKS
#define _G_VTABLE_LABEL_PREFIX "__vt_"
#define _G_VTABLE_LABEL_PREFIX_ID __vt_

#define _G_ARGS(ARGLIST) ARGLIST

#define _IO_pos_t _G_fpos_t 
#define _IO_fpos_t _G_fpos_t
#define _IO_size_t _G_size_t
#define _IO_ssize_t _G_ssize_t
#define _IO_off_t _G_off_t
#define _IO_pid_t _G_pid_t
#define _IO_uid_t _G_uid_t
#define _IO_HAVE_SYS_WAIT _G_HAVE_SYS_WAIT
#define _IO_HAVE_ST_BLKSIZE _G_HAVE_ST_BLKSIZE
#define _IO_BUFSIZ _G_BUFSIZ
#define _IO_va_list _G_va_list
 
#define __need___va_list

#define __GNUC_VA_LIST

typedef void *__gnuc_va_list;

#define _IO_va_list __gnuc_va_list

#define _PARAMS(protos) __P(protos)

#define _IO_UNIFIED_JUMPTABLES 1

#define EOF (-1)

#define _IOS_INPUT	1
#define _IOS_OUTPUT	2
#define _IOS_ATEND	4
#define _IOS_APPEND	8
#define _IOS_TRUNC	16
#define _IOS_NOCREATE	32
#define _IOS_NOREPLACE	64
#define _IOS_BIN	128

#define _IO_MAGIC 0xFBAD0000 
#define _OLD_STDIO_MAGIC 0xFABC0000 
#define _IO_MAGIC_MASK 0xFFFF0000
#define _IO_USER_BUF 1 
#define _IO_UNBUFFERED 2
#define _IO_NO_READS 4 
#define _IO_NO_WRITES 8 
#define _IO_EOF_SEEN 0x10
#define _IO_ERR_SEEN 0x20
#define _IO_DELETE_DONT_CLOSE 0x40 
#define _IO_LINKED 0x80 
#define _IO_IN_BACKUP 0x100
#define _IO_LINE_BUF 0x200
#define _IO_TIED_PUT_GET 0x400 
#define _IO_CURRENTLY_PUTTING 0x800
#define _IO_IS_APPENDING 0x1000
#define _IO_IS_FILEBUF 0x2000
#define _IO_BAD_SEEN 0x4000

 
#define _IO_SKIPWS 01
#define _IO_LEFT 02
#define _IO_RIGHT 04
#define _IO_INTERNAL 010
#define _IO_DEC 020
#define _IO_OCT 040
#define _IO_HEX 0100
#define _IO_SHOWBASE 0200
#define _IO_SHOWPOINT 0400
#define _IO_UPPERCASE 01000
#define _IO_SHOWPOS 02000
#define _IO_SCIENTIFIC 04000
#define _IO_FIXED 010000
#define _IO_UNITBUF 020000
#define _IO_STDIO 040000
#define _IO_DONT_CLOSE 0100000
#define _IO_BOOLALPHA 0200000


struct _IO_jump_t;  struct _IO_FILE;

typedef void _IO_lock_t;

struct _IO_marker {
  struct _IO_marker *_next;
  struct _IO_FILE *_sbuf;
   

   
  int _pos;

};
*/
/*
struct _IO_FILE {
  int _flags;		 
#define _IO_file_flags _flags
   
  char* _IO_read_ptr;	 
  char* _IO_read_end;	 
  char* _IO_read_base;	 
  char* _IO_write_base;	 
  char* _IO_write_ptr;	 
  char* _IO_write_end;	 
  char* _IO_buf_base;	 
  char* _IO_buf_end;	 
   
  char *_IO_save_base;  
  char *_IO_backup_base;   
  char *_IO_save_end;  

  struct _IO_marker *_markers;

  struct _IO_FILE *_chain;

  int _fileno;
  int _blksize;
  __off_t   _offset;

#define __HAVE_COLUMN 
   
  unsigned short _cur_column;
  char _unused;
  char _shortbuf[1];

  _IO_lock_t *_lock;
};
*/

typedef struct _IO_FILE _IO_FILE;

/*
struct _IO_FILE_plus;
extern struct _IO_FILE_plus _IO_stdin_, _IO_stdout_, _IO_stderr_;
#define _IO_stdin ((_IO_FILE*)(&_IO_stdin_))
#define _IO_stdout ((_IO_FILE*)(&_IO_stdout_))
#define _IO_stderr ((_IO_FILE*)(&_IO_stderr_))
*/

/* 
typedef struct
{
  __ssize_t   (*read)  (struct _IO_FILE *, void *, __ssize_t  )  ;
  __ssize_t   (*write)  (struct _IO_FILE *, const void *, __ssize_t  )  ;
  __off_t   (*seek)  (struct _IO_FILE *, __off_t  , int)  ;
  int (*close)  (struct _IO_FILE *)  ;
} _IO_cookie_io_functions_t;
 
struct _IO_cookie_file {
  struct _IO_FILE file;
  const void *vtable;
  void *cookie;
  _IO_cookie_io_functions_t io_functions;
};
*/
/*
extern int __underflow  (_IO_FILE*)  ;
extern int __uflow  (_IO_FILE*)  ;
extern int __overflow  (_IO_FILE*, int)  ;

#define _IO_getc_unlocked(_fp) ((_fp)->_IO_read_ptr >= (_fp)->_IO_read_end ? __uflow(_fp) : *(unsigned char*)(_fp)->_IO_read_ptr++)
#define _IO_peekc_unlocked(_fp) ((_fp)->_IO_read_ptr >= (_fp)->_IO_read_end && __underflow(_fp) == EOF ? EOF : *(unsigned char*)(_fp)->_IO_read_ptr)

#define _IO_putc_unlocked(_ch, _fp) (((_fp)->_IO_write_ptr >= (_fp)->_IO_write_end) ? __overflow(_fp, (unsigned char)(_ch)) : (unsigned char)(*(_fp)->_IO_write_ptr++ = (_ch)))

#define _IO_feof_unlocked(__fp) (((__fp)->_flags & _IO_EOF_SEEN) != 0)
#define _IO_ferror_unlocked(__fp) (((__fp)->_flags & _IO_ERR_SEEN) != 0)

extern int _IO_getc  (_IO_FILE *__fp)  ;
extern int _IO_putc  (int __c, _IO_FILE *__fp)  ;
extern int _IO_feof  (_IO_FILE *__fp)  ;
extern int _IO_ferror  (_IO_FILE *__fp)  ;

extern int _IO_peekc_locked  (_IO_FILE *__fp)  ;

 
#define _IO_PENDING_OUTPUT_COUNT(_fp)	((_fp)->_IO_write_ptr - (_fp)->_IO_write_base)

extern void _IO_flockfile  (_IO_FILE *)  ;
extern void _IO_funlockfile  (_IO_FILE *)  ;
extern int _IO_ftrylockfile  (_IO_FILE *)  ;


#define _IO_flockfile(_fp) 
#define _IO_funlockfile(_fp) 
#define _IO_ftrylockfile(_fp) 
#define _IO_cleanup_region_start(_fct, _fp) 
#define _IO_cleanup_region_end(_Doit) 

#define _IO_getc(_fp) _IO_getc (_fp)
#define _IO_peekc(_fp) _IO_peekc_locked (_fp)
#define _IO_putc(_ch, _fp) _IO_putc (_ch, _fp)
#define _IO_feof(_fp) _IO_feof (_fp)
#define _IO_ferror(_fp) _IO_ferror (_fp)


extern int _IO_vfscanf  (_IO_FILE*, const char*, __gnuc_va_list , int*)  ;
extern int _IO_vfprintf  (_IO_FILE*, const char*, __gnuc_va_list )  ;
extern __ssize_t   _IO_padn  (_IO_FILE *, int, __ssize_t  )  ;
extern size_t   _IO_sgetn  (_IO_FILE *, void*, size_t  )  ;

extern __off_t   _IO_seekoff  (_IO_FILE*, __off_t  , int, int)  ;
extern __off_t   _IO_seekpos  (_IO_FILE*, __off_t  , int)  ;

extern void _IO_free_backup_area  (_IO_FILE*)  ;
*/

#define BUFSIZ _IO_BUFSIZ


#define _IOFBF 0 
#define _IOLBF 1 
#define _IONBF 2 

#define SEEK_SET 0
#define SEEK_CUR 1
#define SEEK_END 2

typedef struct _IO_FILE FILE;
typedef __off_t   fpos_t;


#define L_tmpnam 19
#define TMP_MAX 238328

#define L_ctermid 9
#define L_cuserid 9

#define FILENAME_MAX 4095

#define __need_FOPEN_MAX	1



#define __defined_FOPEN_MAX
#define FOPEN_MAX 256
 
#define P_tmpdir      "/tmp"


/*
extern FILE *stdin, *stdout, *stderr;  

#define stdin _IO_stdin
#define stdout _IO_stdout
#define stderr _IO_stderr


extern void clearerr  (FILE*)  ;
extern int fclose  (FILE*)  ;
extern int feof  (FILE*)  ;
extern int ferror  (FILE*)  ;
extern int fflush  (FILE*)  ;
extern int fgetc  (FILE *)  ;
extern int fgetpos  (FILE* fp, fpos_t *__pos)  ;
extern char* fgets  (char*, int, FILE*)  ;
extern FILE* fopen  (__const char*, __const char*)  ;
extern FILE* fopencookie  (void *__cookie, __const char *__mode,
			       _IO_cookie_io_functions_t __io_functions)  ;
extern int fprintf  (FILE*, __const char* __format, ...)  ;
extern int fputc  (int, FILE*)  ;
extern int fputs  (__const char *__str, FILE *__fp)  ;
extern size_t fread  (void*, size_t, size_t, FILE*)  ;
extern FILE* freopen  (__const char*, __const char*, FILE*)  ;
extern int fscanf  (FILE *__fp, __const char* __format, ...)  ;
extern int fseek  (FILE* __fp, long int __offset, int __whence)  ;
extern int fsetpos  (FILE* __fp, __const fpos_t *__pos)  ;
extern long int ftell  (FILE* __fp)  ;
extern size_t fwrite  (__const void*, size_t, size_t, FILE*)  ;
extern int getc  (FILE *)  ;
extern int getchar  (void)  ;
extern char* gets  (char*)  ;
extern void perror  (__const char *)  ;
extern int printf  (__const char* __format, ...)  ;
extern int putc  (int, FILE *)  ;
extern int putchar  (int)  ;
extern int puts  (__const char *__str)  ;
extern int remove  (__const char*)  ;
extern int rename  (__const char* __old, __const char* __new)  ;
extern void rewind  (FILE*)  ;
extern int scanf  (__const char* format, ...)  ;
extern void setbuf  (FILE*, char*)  ;
extern void setlinebuf  (FILE*)  ;
extern void setbuffer  (FILE*, char*, int)  ;
extern int setvbuf  (FILE*, char*, int __mode, size_t __size)  ;
extern int sprintf  (char*, __const char* __format, ...)  ;
extern int sscanf  (__const char* string, __const char* __format, ...)  ;
extern FILE* tmpfile  (void)  ;
extern char* tmpnam  (char*)  ;

extern char* tmpnam_r  (char*)  ;


extern char *tempnam  (__const char *__dir, __const char *__pfx)  ;

extern char *__stdio_gen_tempname  (char *__buf, size_t bufsize,
					__const char *dir, __const char *pfx,
					int dir_search, size_t *lenptr,
					FILE **streamptr)  ;
extern int ungetc  (int c, FILE* fp)  ;
extern int vfprintf  (FILE *fp, char __const *fmt0, __gnuc_va_list )  ;
extern int vprintf  (char __const *fmt, __gnuc_va_list )  ;
extern int vsprintf  (char* string, __const char* format, __gnuc_va_list )  ;
extern void __libc_fatal  (__const char *__message)  
     __attribute__ ((__noreturn__));


extern int dprintf  (int, __const char *, ...)  ;
extern int vdprintf  (int, __const char *, __gnuc_va_list )  ;
extern int vfscanf  (FILE*, __const char *, __gnuc_va_list )  ;
extern int __vfscanf  (FILE*, __const char *, __gnuc_va_list )  ;
extern int vscanf  (__const char *, __gnuc_va_list )  ;
extern int vsscanf  (__const char *, __const char *, __gnuc_va_list )  ;
extern int __vsscanf  (__const char *, __const char *, __gnuc_va_list )  ;

extern FILE *fdopen  (int, __const char *)  ;
extern int fileno  (FILE*)  ;
extern FILE* popen  (__const char*, __const char*)  ;
extern int pclose  (FILE*)  ;
*/

//#define L_ctermid     9
//#define L_cuserid     9

/* 
extern char *ctermid  (char *__buf)  ;

 
extern char *cuserid  (char * __buf)  ;


extern int snprintf  (char *, size_t, __const char *, ...)  ;
extern int __snprintf  (char *, size_t, __const char *, ...)  ;
extern int vsnprintf  (char *, size_t, __const char *, __gnuc_va_list )  ;
extern int __vsnprintf  (char *, size_t, __const char *, __gnuc_va_list )  ;

extern int __underflow  (struct _IO_FILE*)  ;
extern int __overflow  (struct _IO_FILE*, int)  ;


extern int sys_nerr;
extern const char *const sys_errlist[];

extern void clearerr_locked  (FILE *)  ;
extern void clearerr_unlocked  (FILE *)  ;
extern int feof_locked  (FILE *)  ;
extern int feof_unlocked  (FILE *)  ;
extern int ferror_locked  (FILE*)  ;
extern int ferror_unlocked  (FILE*)  ;
extern int fileno_locked  (FILE *)  ;
extern int fileno_unlocked  (FILE *)  ;
extern int fclose_unlocked  (FILE *)  ;
extern int fflush_locked  (FILE *)  ;
extern int fflush_unlocked  (FILE *)  ;
extern size_t fread_unlocked  (void *, size_t, size_t, FILE *)  ;
extern size_t fwrite_unlocked  (const void *, size_t, size_t, FILE *)  ;

extern int fputc_locked  (int, FILE*)  ;
extern int fputc_unlocked  (int, FILE*)  ;
extern int getc_locked  (FILE *)  ;
extern int getchar_locked  (void)  ;
extern int putc_locked  (int, FILE *)  ;
extern int putchar_locked  (int)  ;


#define getc_locked(fp) _IO_getc (fp)
#define getchar_locked() _IO_getc (stdin)
#define putchar_locked(c) _IO_putc (c, stdout)
 
extern void flockfile  (FILE *)  ;
extern void funlockfile  (FILE *)  ;
extern int ftrylockfile  (FILE *)  ;

extern int getc_unlocked  (FILE *)  ;
extern int getchar_unlocked  (void)  ;
extern int putc_unlocked  (int, FILE *)  ;
extern int putchar_unlocked  (int)  ;


#define getc_unlocked(fp) _IO_getc_unlocked (fp)
#define getchar_unlocked() _IO_getc_unlocked (stdin)
#define putc_unlocked(c, fp) _IO_putc_unlocked ((c), (fp))
#define putchar_unlocked(c) _IO_putc_unlocked ((c), stdout)



#define getc(_fp) _IO_getc (_fp)
#define putc(_ch, _fp) _IO_putc (_ch, _fp)
#define putchar(_ch) _IO_putc (_ch, stdout)
#define getchar() _IO_getc (stdin)
*/

//#define	__P(protos)	protos		

#define	DB_VERSION_MAJOR	3
#define	DB_VERSION_MINOR	0
#define	DB_VERSION_PATCH	55
#define	DB_VERSION_STRING	"Sleepycat Software: Berkeley DB 3.0.55: (November 15, 1999)"

typedef	u_int32_t	db_pgno_t;	 
typedef	u_int16_t	db_indx_t;	 
#define	DB_MAX_PAGES	0xffffffff	

typedef	u_int32_t	db_recno_t;	 
#define	DB_MAX_RECORDS	0xffffffff	

 
struct __db;		typedef struct __db DB;

struct __db_bt_stat;	typedef struct __db_bt_stat DB_BTREE_STAT;
struct __db_dbt;	typedef struct __db_dbt DBT;
struct __db_env;	typedef struct __db_env DB_ENV;
struct __db_h_stat;	typedef struct __db_h_stat DB_HASH_STAT;
struct __db_ilock;	typedef struct __db_ilock DB_LOCK_ILOCK;
struct __db_lock_stat;	typedef struct __db_lock_stat DB_LOCK_STAT;
struct __db_lock_u;	typedef struct __db_lock_u DB_LOCK;
struct __db_lockreq;	typedef struct __db_lockreq DB_LOCKREQ;
struct __db_log_stat;	typedef struct __db_log_stat DB_LOG_STAT;
struct __db_lsn;	typedef struct __db_lsn DB_LSN;
struct __db_mpool_finfo;typedef struct __db_mpool_finfo DB_MPOOL_FINFO;
struct __db_mpool_fstat;typedef struct __db_mpool_fstat DB_MPOOL_FSTAT;
struct __db_mpool_stat;	typedef struct __db_mpool_stat DB_MPOOL_STAT;
struct __db_mpoolfile;	typedef struct __db_mpoolfile DB_MPOOLFILE;
struct __db_qam_stat;	typedef struct __db_qam_stat DB_QUEUE_STAT;
struct __db_txn;	typedef struct __db_txn DB_TXN;
struct __db_txn_active;	typedef struct __db_txn_active DB_TXN_ACTIVE;
struct __db_txn_stat;	typedef struct __db_txn_stat DB_TXN_STAT;
struct __dbc;		typedef struct __dbc DBC;
struct __fh_t;		typedef struct __fh_t DB_FH;

 
struct __db_dbt {
//	void	 *data;			 
	DBT	 *data;			 
	u_int32_t size;			 
	u_int32_t ulen;			 
	u_int32_t dlen;			 
	u_int32_t doff;			 

	u_int32_t flags;
};
#define	DB_DBT_INTERNAL	0x001		
#define	DB_DBT_MALLOC	0x002		
#define	DB_DBT_PARTIAL	0x004		
#define	DB_DBT_REALLOC	0x008		
#define	DB_DBT_USERMEM	0x010		

#define	DB_CXX_NO_EXCEPTIONS  0x000001	

#define	DB_XA_CREATE	      0x000002	

#define	DB_CREATE	      0x000001	
#define	DB_NOMMAP	      0x000002	
#define	DB_THREAD	      0x000004	

#define	DB_FORCE	      0x000008	
#define	DB_INIT_CDB	      0x000010	
#define	DB_INIT_LOCK	      0x000020	
#define	DB_INIT_LOG	      0x000040	
#define	DB_INIT_MPOOL	      0x000080	
#define	DB_INIT_TXN	      0x000100	
#define	DB_RECOVER	      0x000200	
#define	DB_RECOVER_FATAL      0x000400	
#define	DB_SYSTEM_MEM	      0x000800	
#define	DB_TXN_NOSYNC	      0x001000	
#define	DB_USE_ENVIRON	      0x002000	
#define	DB_USE_ENVIRON_ROOT   0x004000	

#define	DB_LOCKDOWN	      0x008000	
#define	DB_PRIVATE	      0x010000	
 
#define	DB_TXN_SYNC	      0x000001	
#define	DB_TXN_NOWAIT	      0x000002	

#define	DB_EXCL		      0x000008	
#define	DB_RDONLY	      0x000010	
#define	DB_TRUNCATE	      0x000020	
#define	DB_FCNTL_LOCKING      0x000040	
 
#define	DB_UPGRADE	      0x000001	

#define	DB_LOCK_NORUN		0
#define	DB_LOCK_DEFAULT		1	
#define	DB_LOCK_OLDEST		2	
#define	DB_LOCK_RANDOM		3	
#define	DB_LOCK_YOUNGEST	4	

#define	DB_DUP			0x0001	
#define	DB_DUPSORT		0x0002	
#define	DB_RECNUM		0x0004	
#define	DB_RENUMBER		0x0008	
#define	DB_REVSPLITOFF		0x0010	
#define	DB_SNAPSHOT		0x0020	

struct __db_env {
	FILE		*db_errfile;	 
	const char	*db_errpfx;	 
					 
//	void (*db_errcall)  (const char *, char *)  ;
//	void (*db_feedback)  (DB_ENV *, int, int)  ;
//	void (*db_paniccall)  (DB_ENV *, int)  ;
//	int  (*db_recovery_init)  (DB_ENV *)  ;

	u_int32_t	 verbose;	 

	u_int8_t	*lk_conflicts;	 
	u_int32_t	 lk_modes;	 
	u_int32_t	 lk_max;	 
	u_int32_t	 lk_detect;	 
	 
	u_int32_t	 lg_bsize;	 
	u_int32_t	 lg_max;	 

	u_int32_t	 mp_gbytes;	 
	u_int32_t	 mp_bytes;	 
	size_t		 mp_size;	 
	int		 mp_ncache;	 
	size_t		 mp_mmapsize;	 

	u_int32_t	 tx_max;	 
//	int (*tx_recover)		 
//	     (DB_ENV *, DBT *, DB_LSN *, int, void *)  ;

	int		 db_panic;	 

	 
	char		*db_home;	 
	char		*db_log_dir;	 
	char		*db_tmp_dir;	 

	char	       **db_data_dir;	 
	int		 data_cnt;	 
	int		 data_next;	 

	int		 db_mode;	 

	void		*reginfo;	 
	DB_FH		*lockfhp;	 

	void		*lg_handle;	 

	void		*lk_handle;	 

	void		*mp_handle;	 

	void		*tx_handle;	 

//	int	      (**dtab)		 
//			     (DB_ENV *, DBT *, DB_LSN *, int, void *)  ;
	size_t		 dtab_size;	 

	struct {
		struct __db_env *tqe_next;
		struct __db_env **tqe_prev;
	} links;
	int		 xa_rmid;	 
	DB_TXN		*xa_txn;	 

	void	*cj_internal;		 

//	int  (*close)  (DB_ENV *, u_int32_t)  ;
//	void (*err)  (const DB_ENV *, int, const char *, ...)  ;
//	void (*errx)  (const DB_ENV *, const char *, ...)  ;
//	int  (*open)  (DB_ENV *,
//		const char *, char * const *, u_int32_t, int)  ;
//	int  (*remove)  (DB_ENV *, const char *, char * const *, u_int32_t)  ;
//	void (*set_errcall)  (DB_ENV *, void (*)(const char *, char *))  ;
//	void (*set_errfile)  (DB_ENV *, FILE *)  ;
//	void (*set_errpfx)  (DB_ENV *, const char *)  ;
//	void (*set_feedback)  (DB_ENV *, void (*)(DB_ENV *, int, int))  ;
//	int  (*set_recovery_init)  (DB_ENV *, int (*)(DB_ENV *))  ;
//	int  (*set_mutexlocks)  (DB_ENV *, int)  ;
//	int  (*set_pageyield)  (DB_ENV *, int)  ;
//	int  (*set_panic)  (DB_ENV *, int)  ;
//	void (*set_paniccall)  (DB_ENV *, void (*)(DB_ENV *, int))  ;
//	int  (*set_region_init)  (DB_ENV *, int)  ;
//	int  (*set_tas_spins)  (DB_ENV *, u_int32_t)  ;
//	int  (*set_verbose)  (DB_ENV *, u_int32_t, int)  ;

//	int  (*set_lg_bsize)  (DB_ENV *, u_int32_t)  ;
//	int  (*set_lg_max)  (DB_ENV *, u_int32_t)  ;

//	int  (*set_lk_conflicts)  (DB_ENV *, u_int8_t *, int)  ;
//	int  (*set_lk_detect)  (DB_ENV *, u_int32_t)  ;
//	int  (*set_lk_max)  (DB_ENV *, u_int32_t)  ;

//	int  (*set_mp_mmapsize)  (DB_ENV *, size_t)  ;
//	int  (*set_cachesize)  (DB_ENV *, u_int32_t, u_int32_t, int)  ;

//	int  (*set_tx_max)  (DB_ENV *, u_int32_t)  ;
//	int  (*set_tx_recover)  (DB_ENV *,
//		int (*)(DB_ENV *, DBT *, DB_LSN *, int, void *))  ;

//	int  (*set_func_close)  (DB_ENV *, int (*)(int))  ;
//	int  (*set_func_dirfree)  (DB_ENV *, void (*)(char **, int))  ;
//	int  (*set_func_dirlist)  (DB_ENV *,
//		int (*)(const char *, char ***, int *))  ;
//	int  (*set_func_exists)  (DB_ENV *, int (*)(const char *, int *))  ;
//	int  (*set_func_free)  (DB_ENV *, void (*)(void *))  ;
//	int  (*set_func_fsync)  (DB_ENV *, int (*)(int))  ;
//	int  (*set_func_ioinfo)  (DB_ENV *, int (*)(const char *,
//		int, u_int32_t *, u_int32_t *, u_int32_t *))  ;
//	int  (*set_func_malloc)  (DB_ENV *, void *(*)(size_t))  ;
//	int  (*set_func_map)  (DB_ENV *,
//		int (*)(char *, size_t, int, int, void **))  ;
//	int  (*set_func_open)  (DB_ENV *, int (*)(const char *, int, ...))  ;
//	int  (*set_func_read)  (DB_ENV *, ssize_t  (*)(int, void *, size_t))  ;
//	int  (*set_func_realloc)  (DB_ENV *, void *(*)(void *, size_t))  ;
//	int  (*set_func_rename)  (DB_ENV *,
//		int (*)(const char *, const char *))  ;
//	int  (*set_func_seek)  (DB_ENV *,
//		int (*)(int, size_t, db_pgno_t, u_int32_t, int, int))  ;
//	int  (*set_func_sleep)  (DB_ENV *, int (*)(u_long, u_long))  ;
//	int  (*set_func_unlink)  (DB_ENV *, int (*)(const char *))  ;
//	int  (*set_func_unmap)  (DB_ENV *, int (*)(void *, size_t))  ;
//	int  (*set_func_write)  (DB_ENV *,
//		ssize_t  (*)(int, const void *, size_t))  ;
//	int  (*set_func_yield)  (DB_ENV *, int (*)(void))  ;

	u_int32_t	 flags;		 
};
#define	DB_VERB_CHKPOINT	0x0001	
#define	DB_VERB_DEADLOCK	0x0002	
#define	DB_VERB_RECOVERY	0x0004	
#define	DB_VERB_WAITSFOR	0x0008	

#define	DB_ENV_CDB		0x00001	
#define	DB_ENV_CREATE		0x00002	
#define	DB_ENV_DBLOCAL		0x00004	
#define	DB_ENV_LOCKDOWN		0x00008	
#define	DB_ENV_LOCKING		0x00010	
#define	DB_ENV_LOGGING		0x00020	
#define	DB_ENV_NOMMAP		0x00040	
#define	DB_ENV_OPEN_CALLED	0x00080	
#define	DB_ENV_PRIVATE		0x00100	
#define	DB_ENV_STANDALONE	0x00200	
#define	DB_ENV_SYSTEM_MEM	0x00400	
#define	DB_ENV_THREAD		0x00800	
#define	DB_ENV_TXN		0x01000	
#define	DB_ENV_TXN_NOSYNC	0x02000	
#define	DB_ENV_USER_ALLOC	0x04000	

typedef enum {
	DB_BTREE=1,
	DB_HASH,
	DB_RECNO,
	DB_QUEUE,
	DB_UNKNOWN			 
} DBTYPE;

#define	DB_BTREEVERSION	7		
#define	DB_BTREEOLDVER	6		
#define	DB_BTREEMAGIC	0x053162

#define	DB_HASHVERSION	6		
#define	DB_HASHOLDVER	4		
#define	DB_HASHMAGIC	0x061561

#define	DB_QAMVERSION	1		
#define	DB_QAMOLDVER	1		
#define	DB_QAMMAGIC	0x042253

#define	DB_LOGVERSION	2		
#define	DB_LOGOLDVER	2		
#define	DB_LOGMAGIC	0x040988

#define	DB_AFTER	 1		
#define	DB_APPEND	 2		
#define	DB_BEFORE	 3		
#define	DB_CHECKPOINT	 4		
#define	DB_CONSUME	 5		
#define	DB_CURLSN	 6		
#define	DB_CURRENT	 7		
#define	DB_DUPCURSOR	 8		
#define	DB_FIRST	 9		
#define	DB_FLUSH	10		
#define	DB_GET_BOTH	11		
#define	DB_GET_RECNO	12		
#define	DB_JOIN_ITEM	13		
#define	DB_KEYFIRST	14		
#define	DB_KEYLAST	15		
#define	DB_LAST		16		
#define	DB_NEXT		17		
#define	DB_NEXT_DUP	18		
#define	DB_NEXT_NODUP	19		
#define	DB_NOOVERWRITE	20		
#define	DB_NOSYNC	21		
#define	DB_POSITION	22		
#define	DB_POSITIONI	23		
#define	DB_PREV		24		
#define	DB_RECORDCOUNT	25		
#define	DB_SET		26		
#define	DB_SET_RANGE	27		
#define	DB_SET_RECNO	28		
#define	DB_WRITECURSOR	29		
#define	DB_WRITELOCK	30		
 
#define	DB_OPFLAGS_MASK	0x000000ff	
#define	DB_RMW		0x80000000	

#define	DB_INCOMPLETE		(-30999)
#define	DB_KEYEMPTY		(-30998)
#define	DB_KEYEXIST		(-30997)
#define	DB_LOCK_DEADLOCK	(-30996)
#define	DB_LOCK_NOTGRANTED	(-30995)
#define	DB_NOTFOUND		(-30994)
#define	DB_OLD_VERSION		(-30993)
#define	DB_RUNRECOVERY		(-30992)

 
#define	DB_DELETED		(-30991)
#define	DB_NEEDSPLIT		(-30990)
#define	DB_SWAPBYTES		(-30989)
#define	DB_TXN_CKP		(-30988)

#define	DB_FILE_ID_LEN		20	
 
struct __db {
	size_t	 pgsize;		 
					 
//	void (*db_feedback)  (DB *, int, int)  ;
//	void *(*db_malloc)  (size_t)  ;
//	void *(*db_realloc)  (void *, size_t)  ;
//	int (*dup_compare)  (const DBT *, const DBT *)  ;

	DB_ENV *dbenv;			 

	DBTYPE	 type;			 

	DB_MPOOLFILE *mpf;		 

	void	*mutexp;		 

	u_int8_t fileid[20 ]; 

	int32_t	 log_fileid;		 
	DB_TXN	*open_txn;		 

	DB_FH	*saved_open_fhp;	 

	struct {
		struct __dbc *tqh_first;
		struct __dbc **tqh_last;
	} free_queue;
	struct {
		struct __dbc *tqh_first;
		struct __dbc **tqh_last;
	} active_queue;

	void	*bt_internal;		 
	void	*cj_internal;		 
	void	*h_internal;		 
	void	*q_internal;		 
	void	*xa_internal;		 

/*					 
	int  (*close)  (DB *, u_int32_t)  ;
	int  (*cursor)  (DB *, DB_TXN *, DBC **, u_int32_t)  ;
	int  (*del)  (DB *, DB_TXN *, DBT *, u_int32_t)  ;
	void (*err)  (DB *, int, const char *, ...)  ;
	void (*errx)  (DB *, const char *, ...)  ;
	int  (*fd)  (DB *, int *)  ;
	int  (*get)  (DB *, DB_TXN *, DBT *, DBT *, u_int32_t)  ;
	int  (*get_byteswapped)  (DB *)  ;
	DBTYPE
	     (*get_type)  (DB *)  ;
	int  (*join)  (DB *, DBC **, DBC **, u_int32_t)  ;
	int  (*open)  (DB *,
		const char *, const char *, DBTYPE, u_int32_t, int)  ;
	int  (*put)  (DB *, DB_TXN *, DBT *, DBT *, u_int32_t)  ;
	int  (*remove)  (DB *, const char *, const char *, u_int32_t)  ;
	int  (*set_cachesize)  (DB *, u_int32_t, u_int32_t, int)  ;
	int  (*set_dup_compare)  (DB *, int (*)(const DBT *, const DBT *))  ;
	void (*set_errcall)  (DB *, void (*)(const char *, char *))  ;
	void (*set_errfile)  (DB *, FILE *)  ;
	void (*set_errpfx)  (DB *, const char *)  ;
	void (*set_feedback)  (DB *, void (*)(DB *, int, int))  ;
	int  (*set_flags)  (DB *, u_int32_t)  ;
	int  (*set_lorder)  (DB *, int)  ;
	int  (*set_malloc)  (DB *, void *(*)(size_t))  ;
	int  (*set_pagesize)  (DB *, u_int32_t)  ;
	void (*set_paniccall)  (DB *, void (*)(DB_ENV *, int))  ;
	int  (*set_realloc)  (DB *, void *(*)(void *, size_t))  ;
	int  (*stat)  (DB *, void *, void *(*)(size_t), u_int32_t)  ;
	int  (*sync)  (DB *, u_int32_t)  ;
	int  (*upgrade)  (DB *, const char *, u_int32_t)  ;

	int  (*set_bt_compare)  (DB *, int (*)(const DBT *, const DBT *))  ;
	int  (*set_bt_maxkey)  (DB *, u_int32_t)  ;
	int  (*set_bt_minkey)  (DB *, u_int32_t)  ;
	int  (*set_bt_prefix)  (DB *, size_t (*)(const DBT *, const DBT *))  ;

	int  (*set_h_ffactor)  (DB *, u_int32_t)  ;
	int  (*set_h_hash)  (DB *, u_int32_t (*)(const void *, u_int32_t))  ;
	int  (*set_h_nelem)  (DB *, u_int32_t)  ;

	int  (*set_re_delim)  (DB *, int)  ;
	int  (*set_re_len)  (DB *, u_int32_t)  ;
	int  (*set_re_pad)  (DB *, int)  ;
	int  (*set_re_source)  (DB *, const char *)  ;
*/
	u_int32_t	am_ok;		 

	u_int32_t flags;
};
#define	DB_LOGFILEID_INVALID	-1

#define	DB_OK_BTREE	0x01
#define	DB_OK_HASH	0x02
#define	DB_OK_QUEUE	0x04
#define	DB_OK_RECNO	0x08

#define	DB_AM_DISCARD	0x00001		
#define	DB_AM_DUP	0x00002		
#define	DB_AM_INMEM	0x00004		
#define	DB_AM_PGDEF	0x00008		
#define	DB_AM_RDONLY	0x00010		
#define	DB_AM_SUBDB	0x00020		
#define	DB_AM_SWAP	0x00040		
#define	DB_BT_RECNUM	0x00080		
#define	DB_BT_REVSPLIT	0x00100		
#define	DB_DBM_ERROR	0x00200		
#define	DB_OPEN_CALLED	0x00400		
#define	DB_RE_DELIMITER	0x00800		
#define	DB_RE_FIXEDLEN	0x01000		
#define	DB_RE_PAD	0x02000		
#define	DB_RE_RENUMBER	0x04000		
#define	DB_RE_SNAPSHOT	0x08000		

struct __db_ilock {
	db_pgno_t pgno;			 
	u_int8_t fileid[20 ]; 
	u_int8_t type;			 
};
#define DB_RECORD_LOCK	1
#define DB_PAGE_LOCK	2

struct __db_lock_u {
	size_t		off;		 
	u_int32_t	ndx;		 

	u_int32_t	gen;		 
};

 
struct __dbc {
	DB *dbp;			 
	DB_TXN	 *txn;			 

	struct {
		struct __dbc *tqe_next;
		struct __dbc **tqe_prev;
	} links;

	u_int32_t lid;			 
	u_int32_t locker;		 
	DBT	  lock_dbt;		 
	DB_LOCK_ILOCK lock;		 
	DB_LOCK	mylock;			 

	DBT rkey;			 
	DBT rdata;			 
/*
	int (*c_close)  (DBC *)  ;	 
	int (*c_del)  (DBC *, u_int32_t)  ;
	int (*c_dup)  (DBC *, DBC **, u_int32_t)  ;
	int (*c_get)  (DBC *, DBT *, DBT *, u_int32_t)  ;
	int (*c_put)  (DBC *, DBT *, DBT *, u_int32_t)  ;

	int (*c_am_close)  (DBC *)  ;	 
	int (*c_am_destroy)  (DBC *)  ;
	int (*c_close)  (DBC *)  ;	 
	int (*c_del)  (DBC *, u_int32_t)  ;
	int (*c_dup)  (DBC *, DBC **, u_int32_t)  ;
	int (*c_get)  (DBC *, DBT *, DBT *, u_int32_t)  ;
	int (*c_put)  (DBC *, DBT *, DBT *, u_int32_t)  ;

	int (*c_am_close)  (DBC *)  ;	 
	int (*c_am_destroy)  (DBC *)  ;
*/
	void	 *internal;		 

	u_int32_t flags;
};
#define	DBC_CONTINUE	0x001		
#define	DBC_RECOVER	0x002		
#define	DBC_RMW		0x004		
#define	DBC_WRITECURSOR	0x008		
#define	DBC_WRITER	0x010		

 
struct __db_bt_stat {
	u_int32_t bt_metaflags;		 
	u_int32_t bt_maxkey;		 
	u_int32_t bt_minkey;		 
	u_int32_t bt_re_len;		 
	u_int32_t bt_re_pad;		 
	u_int32_t bt_pagesize;		 
	u_int32_t bt_levels;		 
	u_int32_t bt_nrecs;		 
	u_int32_t bt_int_pg;		 
	u_int32_t bt_leaf_pg;		 
	u_int32_t bt_dup_pg;		 
	u_int32_t bt_over_pg;		 
	u_int32_t bt_free;		 
	u_int32_t bt_int_pgfree;	 
	u_int32_t bt_leaf_pgfree;	 
	u_int32_t bt_dup_pgfree;	 
	u_int32_t bt_over_pgfree;	 
	u_int32_t bt_magic;		 
	u_int32_t bt_version;		 
};

 
struct __db_qam_stat {
	u_int32_t qs_magic;		 
	u_int32_t qs_version;		 
	u_int32_t qs_metaflags;		 
	u_int32_t qs_nrecs;		 
	u_int32_t qs_pages;		 
	u_int32_t qs_pagesize;		 
	u_int32_t qs_pgfree;		 
	u_int32_t qs_re_len;		 
	u_int32_t qs_re_pad;		 
	u_int32_t qs_start;		 
	u_int32_t qs_first_recno;	 
	u_int32_t qs_cur_recno;		 
};

 
struct __db_h_stat {
	u_int32_t hash_magic;		 
	u_int32_t hash_version;		 
	u_int32_t hash_metaflags;	 
	u_int32_t hash_pagesize;	 
	u_int32_t hash_nelem;		 
	u_int32_t hash_ffactor;		 
	u_int32_t hash_nrecs;		 
	u_int32_t hash_buckets;		 
	u_int32_t hash_free;		 
	u_int32_t hash_bfree;		 
	u_int32_t hash_bigpages;	 
	u_int32_t hash_big_bfree;	 
	u_int32_t hash_overflows;	 
	u_int32_t hash_ovfl_free;	 
	u_int32_t hash_dup;		 
	u_int32_t hash_dup_free;	 
};

int   db_create  (DB **, DB_ENV *, u_int32_t)  ;
int   db_env_create  (DB_ENV **, u_int32_t)  ;
char *db_strerror  (int)  ;
char *db_version  (int *, int *, int *)  ;

#define	DB_LOCKVERSION	1
 
#define	DB_LOCK_NOWAIT		0x01	
#define	DB_LOCK_RECORD		0x02	
#define	DB_LOCK_UPGRADE		0x04	
 
#define	DB_LOCK_CONFLICT	0x01	

typedef enum {
	DB_LOCK_DUMP=0,			 
	DB_LOCK_GET,			 
	DB_LOCK_INHERIT,		 
	DB_LOCK_PUT,			 
	DB_LOCK_PUT_ALL,		 
	DB_LOCK_PUT_OBJ			 
} db_lockop_t;

typedef enum {
	DB_LOCK_NG=0,			 
	DB_LOCK_READ,			 
	DB_LOCK_WRITE,			 
	DB_LOCK_IWRITE,			 
	DB_LOCK_IREAD,			 
	DB_LOCK_IWR			 
} db_lockmode_t;

typedef enum {
	DB_LSTAT_ABORTED,		 
	DB_LSTAT_ERR,			 
	DB_LSTAT_FREE,			 
	DB_LSTAT_HELD,			 
	DB_LSTAT_NOGRANT,		 
	DB_LSTAT_PENDING,		 

	DB_LSTAT_WAITING		 
} db_status_t;

 
struct __db_lockreq {
	db_lockop_t	 op;		 
	db_lockmode_t	 mode;		 
	u_int32_t	 locker;	 
	DBT		*obj;		 
	DB_LOCK		 lock;		 
};

#define	DB_LOCK_RW_N	3
//extern const u_int8_t db_rw_conflicts[];

 
#define	DB_LOCK_RIW_N	6
//extern const u_int8_t db_riw_conflicts[];

struct __db_lock_stat {
	u_int32_t st_lastid;		 
	u_int32_t st_maxlocks;		 
	u_int32_t st_nmodes;		 
	u_int32_t st_nlockers;		 
	u_int32_t st_maxnlockers;	 
	u_int32_t st_nconflicts;	 
	u_int32_t st_nrequests;		 
	u_int32_t st_nreleases;		 
	u_int32_t st_ndeadlocks;	 
	u_int32_t st_region_wait;	 
	u_int32_t st_region_nowait;	 
	u_int32_t st_regsize;		 
};


int	  lock_detect  (DB_ENV *, u_int32_t, u_int32_t, int *)  ;
int	  lock_get  (DB_ENV *,
	    u_int32_t, u_int32_t, const DBT *, db_lockmode_t, DB_LOCK *)  ;
int	  lock_id  (DB_ENV *, u_int32_t *)  ;
int	  lock_put  (DB_ENV *, DB_LOCK *)  ;
//***int	  lock_stat  (DB_ENV *, DB_LOCK_STAT **, void *(*)(size_t))  ;
int	  lock_vec  (DB_ENV *,
	    u_int32_t, u_int32_t, DB_LOCKREQ *, int, DB_LOCKREQ **)  ;
 
#define	DB_ARCH_ABS		0x001	
#define	DB_ARCH_DATA		0x002	
#define	DB_ARCH_LOG		0x004	

/*
struct __db_lsn {
	u_int32_t	file;		 
	u_int32_t	offset;		 
};
 
struct __db_log_stat {
	u_int32_t st_magic;		 
	u_int32_t st_version;		 
	int st_mode;			 
	u_int32_t st_lg_bsize;		 
	u_int32_t st_lg_max;		 
	u_int32_t st_w_bytes;		 
	u_int32_t st_w_mbytes;		 
	u_int32_t st_wc_bytes;		 
	u_int32_t st_wc_mbytes;		 
	u_int32_t st_wcount;		 
	u_int32_t st_wcount_fill;	 
	u_int32_t st_scount;		 
	u_int32_t st_region_wait;	 
	u_int32_t st_region_nowait;	 
	u_int32_t st_cur_file;		 
	u_int32_t st_cur_offset;	 
	u_int32_t st_regsize;		 
};
*/

//***int	 log_archive  (DB_ENV *, char **[], u_int32_t, void *(*)(size_t))  ;
int	 log_compare  (const DB_LSN *, const DB_LSN *)  ;
int	 log_file  (DB_ENV *, const DB_LSN *, char *, size_t)  ;
int	 log_flush  (DB_ENV *, const DB_LSN *)  ;
int	 log_get  (DB_ENV *, DB_LSN *, DBT *, u_int32_t)  ;
int	 log_put  (DB_ENV *, DB_LSN *, const DBT *, u_int32_t)  ;
int	 log_register  (DB_ENV *, DB *, const char *, int32_t *)  ;
//***int	 log_stat  (DB_ENV *, DB_LOG_STAT **, void *(*)(size_t))  ;
int	 log_unregister  (DB_ENV *, int32_t)  ;
 
#define	DB_MPOOL_CREATE		0x001	
#define	DB_MPOOL_LAST		0x002	
#define	DB_MPOOL_NEW		0x004	
#define	DB_MPOOL_NEW_GROUP	0x008	

 
#define	DB_MPOOL_CLEAN		0x001	
#define	DB_MPOOL_DIRTY		0x002	
#define	DB_MPOOL_DISCARD	0x004	

 
struct __db_mpool_stat {
	u_int32_t st_cache_hit;		 
	u_int32_t st_cache_miss;	 
	u_int32_t st_map;		 
	u_int32_t st_page_create;	 
	u_int32_t st_page_in;		 
	u_int32_t st_page_out;		 
	u_int32_t st_ro_evict;		 
	u_int32_t st_rw_evict;		 
	u_int32_t st_hash_buckets;	 
	u_int32_t st_hash_searches;	 
	u_int32_t st_hash_longest;	 
	u_int32_t st_hash_examined;	 
	u_int32_t st_page_clean;	 
	u_int32_t st_page_dirty;	 
	u_int32_t st_page_trickle;	 
	u_int32_t st_region_wait;	 
	u_int32_t st_region_nowait;	 
	u_int32_t st_regsize;		 
	u_int32_t st_gbytes;		 
	u_int32_t st_bytes;		 
};

 
struct __db_mpool_finfo {
	int	   ftype;		 
	DBT	  *pgcookie;		 
	u_int8_t  *fileid;		 
	int32_t	   lsn_offset;		 
	u_int32_t  clear_len;		 
};

 
struct __db_mpool_fstat {
	char *file_name;		 
	size_t st_pagesize;		 
	u_int32_t st_cache_hit;		 
	u_int32_t st_cache_miss;	 
	u_int32_t st_map;		 
	u_int32_t st_page_create;	 
	u_int32_t st_page_in;		 
	u_int32_t st_page_out;		 
};


int	memp_fclose  (DB_MPOOLFILE *)  ;
int	memp_fget  (DB_MPOOLFILE *, db_pgno_t *, u_int32_t, void *)  ;
int	memp_fopen  (DB_ENV *, const char *,
	    u_int32_t, int, size_t, DB_MPOOL_FINFO *, DB_MPOOLFILE **)  ;
int	memp_fput  (DB_MPOOLFILE *, void *, u_int32_t)  ;
int	memp_fset  (DB_MPOOLFILE *, void *, u_int32_t)  ;
int	memp_fsync  (DB_MPOOLFILE *)  ;
/***
int	memp_register  (DB_ENV *, int,
	    int (*)(db_pgno_t, void *, DBT *),
	    int (*)(db_pgno_t, void *, DBT *))  ;
int	memp_stat  (DB_ENV *,
	    DB_MPOOL_STAT **, DB_MPOOL_FSTAT ***, void *(*)(size_t))  ;
*/
int	memp_sync  (DB_ENV *, DB_LSN *)  ;
int	memp_trickle  (DB_ENV *, int, int *)  ;

#define	DB_TXNVERSION	1
 
#define	DB_TXN_BACKWARD_ROLL	1	
#define	DB_TXN_FORWARD_ROLL	2	
#define	DB_TXN_OPENFILES	3	
#define	DB_TXN_REDO		4	
#define	DB_TXN_UNDO		5	
 
struct __db_txn_active {
	u_int32_t	txnid;		 
	u_int32_t	parentid;	 
	DB_LSN		lsn;		 
};

struct __db_txn_stat {
	DB_LSN	  st_last_ckp;		 
	DB_LSN	  st_pending_ckp;	 
	time_t	  st_time_ckp;		 
	u_int32_t st_last_txnid;	 
	u_int32_t st_maxtxns;		 
	u_int32_t st_naborts;		 
	u_int32_t st_nbegins;		 
	u_int32_t st_ncommits;		 
	u_int32_t st_nactive;		 
	u_int32_t st_maxnactive;	 
	DB_TXN_ACTIVE
		 *st_txnarray;		 
	u_int32_t st_region_wait;	 
	u_int32_t st_region_nowait;	 
	u_int32_t st_regsize;		 
};


int	  txn_abort  (DB_TXN *)  ;
int	  txn_begin  (DB_ENV *, DB_TXN *, DB_TXN **, u_int32_t)  ;
int	  txn_checkpoint  (DB_ENV *, u_int32_t, u_int32_t)  ;
int	  txn_commit  (DB_TXN *, u_int32_t)  ;
u_int32_t txn_id  (DB_TXN *)  ;
int	  txn_prepare  (DB_TXN *)  ;
//***int	  txn_stat  (DB_ENV *, DB_TXN_STAT **, void *(*)(size_t))  ;


#define	DB_DBM_HSEARCH	0		
