indexing
   description : "Example for using the Recno access methods"
   project     : "EiffelBDB - An Eiffel interface to the Berkeley DB"
   author      : "Pirmin Kalberer <kalberer@spin.ch>"
   copyright   : "Copyright (c) 1999, Pirmin Kalberer"
   date        : "$Date: 2000/01/08 16:19:08 $"
   revision    : "$Revision: 1.1 $"

class RECNO_EXAMPLE
   
creation
   make
   
feature { NONE }
   
   filename: STRING is "access.db"
   subname: STRING -- default = Void -> no subname
   
   wordlist: ARRAY[STRING] is
      once
	 Result := <<"Wall", "Larry",
		     "Smith", "John",
		     "mouse", "mickey",
		     "duck", "donald",
		     >>
      end
		     
feature
   
   make is
      local
	 db: BDB_DB
	 env: BDB_ENV -- default = Void -> no environment
	 txn: BDB_TXN -- default = Void -> no transaction handling
	 key, data: STRING
	 dbcp: BDB_C
	 no_flags: INTEGER
	 recno, i: INTEGER
      do
	 !!db.make(env, no_flags)
      
	 db.open(filename, subname, db.Db_recno_const, db.Db_create_const + db.Db_truncate_const, 420) -- 420 = octal 644
	 
	 -- Insert records into the database.
	 from
	    i := wordlist.lower
	 until
	    i > wordlist.upper
	 loop
	    recno := db.put_last(txn, wordlist.item(i))
	    i := i + 1
	 end
	 
	 -- Acquire a cursor for the table.
	 dbcp := db.cursor(txn, no_flags)
         
	 -- Walk through the table, printing the record data.
	 from
	    dbcp.first
	 until 
	    dbcp.off
	 loop
	    print(dbcp.last_record.value); print("%N")
	    dbcp.forth
	 end
	 dbcp.close
	 
	 -- Search and print one record
	 db.get_recno(txn, 8, no_flags)
	 if db.last_result = db.Db_notfound_const then
	    print("Record not found%N")
	 else
	    print(db.last_record.value); print("%N")
	 end
	 
	 db.close(no_flags)
      end -- make
   
end
