indexing
   description : "Optimized string class"
   project     : "EiffelBDB - An Eiffel interface to the Berkeley DB"
   author      : "Pirmin Kalberer <kalberer@spin.ch>"
   copyright   : "Copyright (c) 1999, Pirmin Kalberer"
   date        : "$Date: 2000/01/08 16:19:16 $"
   revision    : "$Revision: 1.2 $"
	 
class BDB_STRING
   
inherit
   STRING
   
creation
   make, make_from_string, make_from_dbt, make_initialized
   
feature
   
   make_from_dbt(p: POINTER; size: INTEGER) is
	 -- new string with `size' and copied data from `p'
      do
	 count := size
	 capacity := size + 1 -- size+1 for C string null character
         storage := storage.calloc(capacity)
	 if count > 0 then
             storage.copy_from(storage.from_pointer(p), count)
	 end
      end

   make_initialized(size: INTEGER) is
         -- Allocate the string to have at least `size'
         -- characters of storage and initialize it with \0
      do
	 make(size+1) -- size+1 for C string null character
	 count := size
	 fill('%U')
      ensure
	 count = size
      end
   
end
